Index: romio/README
===================================================================
RCS file: /home/MPI/cvsMaster/romio/README,v
retrieving revision 1.26
retrieving revision 1.27
--- romio/README	18 Feb 2003 16:31:47 -0000	1.26
+++ romio/README	26 May 2004 17:56:42 -0000	1.27
@@ -253,20 +253,21 @@
 mv, cp, rm, ftp.
 
 
 Using ROMIO on NFS
 ------------------
 
 To use ROMIO on NFS, file locking with fcntl must work correctly on
 the NFS installation. On some installations, fcntl locks don't work.
-To get them to work, you need to use Version 3 of NFS and
-have the system administrator mount the NFS file system with the 
-"noac" option (no attribute caching). Turning off attribute caching 
-may reduce performance, but it is necessary for correct behavior.
+To get them to work, you need to use Version 3 of NFS, ensure that the
+lockd daemon is running on all the machines, and have the system
+administrator mount the NFS file system with the "noac" option (no
+attribute caching). Turning off attribute caching may reduce
+performance, but it is necessary for correct behavior.
 
 The following are some instructions we received from Ian Wells of HP
 for setting the noac option on NFS. We have not tried them
 ourselves. We are including them here because you may find 
 them useful. Note that some of the steps may be specific to HP
 systems, and you may need root permission to execute some of the
 commands. 
    
Index: romio/configure.in
===================================================================
RCS file: /home/MPI/cvsMaster/romio/configure.in,v
retrieving revision 1.98
retrieving revision 1.113
--- romio/configure.in	10 Dec 2003 22:44:11 -0000	1.98
+++ romio/configure.in	8 Jun 2004 19:13:59 -0000	1.113
@@ -76,16 +76,22 @@
 TEST_F77=""
 TRY_WEAK_SYMBOLS=1
 #
 # Error handlers (not used with MPICH2, which provides its own routines)
 MPIO_EXTRA_OBJECTS="get_errh.o set_errh.o"
 MPIO_EXTRA_TMP_POBJECTS="get_errh.p set_errh.p"
 MPIO_EXTRA_REAL_POBJECTS="_get_errh.o _set_errh.o"
 #
+# Completion routines for MPIO_Requests.  MPI Implementations with
+# generalized requests do not need these
+MPIO_REQOBJECTS="iotest.o iotestall.o iotestany.o iotestsome.o iowait.o iowaitall.o iowaitany.o iowaitsome.o ioreq_c2f.o ioreq_f2c.o"
+MPIO_REQ_TMP_POBJECTS="iotest.p iowait.p iowaitall.p iowaitany.p iotestall.p iotestany.p iowaitsome.p iotestsome.p"
+MPIO_REQ_REAL_POBJECTS="_iotest.o _iowait.o _iowaitall.o _iowaitany.o _iotestall.o _iotestany.o _iowaitsome.o _iotestsome.o"
+#
 have_aio=no
 #
 known_filesystems="nfs ufs pfs piofs pvfs pvfs2 testfs xfs hfs sfs"
 known_mpi_impls="mpich_mpi sgi_mpi hp_mpi cray_mpi lam_mpi"
 #
 # Defaults
 AC_ARG_ENABLE(aio,[
 --enable-aio - Request use of asynchronous I/O routines],,enable_aio=notgiven)
@@ -280,17 +286,17 @@
 # --------------------------------------------------------------------------
 # For historical reasons
 if test -z "$FC" ; then 
     FC=$F77
 fi
 #
 C_DEBUG_FLAG="-g"
 F77_DEBUG_FLAG="-g"
-C_OPT_FLAG="-O"
+C_OPT_FLAG=${CFLAGS:-"-O"}
 case $ARCH in 
      sun4)
      CC=${CC:-gcc}
      F77=${FC:-f77}
      ;;
 
      solaris|solaris86)
      CC=${CC:-cc}
@@ -884,16 +890,20 @@
 # If no system selected, turn of AIO
 if test "$have_aio" != yes ; then
     AC_DEFINE(NO_AIO,1,[Define if AIO should not be used])
 fi
 
 
 AC_HAVE_FUNCS(memalign)
 
+#
+# Question: Should ROMIO under MPICH2 ignore the Fortran tests, since 
+# MPICH2 provides all of the Fortran interface routines?
+#
 if test $NOF77 = 0 ; then
     echo "checking Fortran external names"
     PAC_GET_FORTNAMES
     if test -n "$WDEF" ; then
         CFLAGS="$CFLAGS $WDEF"
     fi
     dnl PAC_PROG_F77_NAME_MANGLE
     dnl (need to set the new name format)
@@ -1012,17 +1022,24 @@
    fi
    PAC_TEST_MPI_SGI_type_is_contig
    PAC_TEST_MPI_COMBINERS
    PAC_TEST_MPI_HAVE_OFFSET_KIND
 fi
 #
 # check if darray and subarray constructors are defined in the MPI 
 # implementation 
-if test $WITHIN_KNOWN_MPI_IMPL = no -o $FROM_MPICH2 != no ; then
+if test $WITHIN_KNOWN_MPI_IMPL = no ; then
    PAC_MPI_DARRAY_SUBARRAY
-else
+fi
+if test $FROM_MPICH2 = yes ; then
+   dnl Made this a message instead of a warning because the warning is
+   dnl likely to confuse users.
+   AC_MSG_RESULT("Overriding Array test for MPICH2")
+   dnl unset BUILD_MPI_ARRAY
+   dnl AC_DEFINE(HAVE_MPI_DARRAY_SUBARRAY,1,[Define if Darray is available])
+   dnl HAVE_MPI_DARRAY_SUBARRAY="#define HAVE_MPI_DARRAY_SUBARRAY"
    MPI_FARRAY1="!"
    MPI_FARRAY2="!"
    MPI_FARRAY3="!"
    MPI_FARRAY4="!"
    MPI_FARRAY5="!"
    MPI_FARRAY6="!"
@@ -1041,34 +1058,39 @@
 # Fortran interface for HP already uses one secondary defn. 
 # therefore, do not use this method for profiling interface.
 # build profiling interface explicitly.
    TRY_WEAK_SYMBOLS=0
 fi
 if test $TRY_WEAK_SYMBOLS = 1 ; then
   AC_MSG_CHECKING([for weak symbol support])
   AC_TRY_LINK([
-extern int Foo(int);
+extern int PFoo(int);
 #pragma weak PFoo = Foo
-int Foo(a) { return a; }
+int Foo(int a) { return a; }
 ],[return PFoo(1);],has_pragma_weak=1)
   #
   # Some systems (Linux ia64 and ecc, for example), support weak symbols
   # only within a single object file!  This tests that case.
+  # Note that there is an extern int PFoo declaration before the
+  # pragma.  Some compilers require this in order to make the weak symbol
+  # extenally visible.  
   if test "$has_pragma_weak" = 1 ; then
     AC_MSG_RESULT([pragma weak])
     AC_MSG_CHECKING([that weak symbols are visible to other files])
     rm -f conftest*
     cat >>conftest1.c <<EOF
-extern int Foo(int);
+extern int PFoo(int);
 #pragma weak PFoo = Foo
-int Foo(a) { return a; }
+int Foo(int);
+int Foo(int a) { return a; }
 EOF
     cat >>conftest2.c <<EOF
-int main() {
+extern int PFoo(int);
+int main(int argc, char **argv) {
 return PFoo(0);}
 EOF
     ac_link2='${CC-cc} -o conftest $CFLAGS $CPPFLAGS $LDFLAGS conftest1.c conftest2.c $LIBS >conftest.out 2>&1'
     if eval $ac_link2 ; then
         AC_MSG_RESULT(yes)
     else
       echo "$ac_link2" 1>&AC_FD_CC
       echo "Failed program was" 1>&AC_FD_CC
@@ -1080,27 +1102,29 @@
     fi
     rm -f conftest*
   fi
   if test "$has_pragma_weak" = 1 ; then
     HAVE_WEAK_SYMBOLS=1
     AC_DEFINE(HAVE_PRAGMA_WEAK,1,[Define if pragma weak available])
   else
     AC_TRY_LINK([
+extern int PFoo(int);
 #pragma _HP_SECONDARY_DEF Foo PFoo
-int Foo(a) { return a; }
+int Foo(int a) { return a; }
 ],[return PFoo(1);],has_pragma_hp_secondary=1)
     if test "$has_pragma_hp_secondary" = 1 ; then 
         AC_MSG_RESULT([pragma _HP_SECONDARY_DEF])
         HAVE_WEAK_SYMBOLS=1
         AC_DEFINE(HAVE_PRAGMA_HP_SEC_DEF,1,[Define for HP weak pragma])
     else
         AC_TRY_LINK([
+extern int PFoo(int);
 #pragma _CRI duplicate PFoo as Foo
-int Foo(a) { return a; }
+int Foo(int a) { return a; }
 ],[return PFoo(1);],has_pragma_cri_duplicate=1)
         if test "$has_pragma_cri_duplicate" = 1 ; then
 	    AC_MSG_RESULT([pragma _CRI duplicate x as y])
 	    HAVE_WEAK_SYMBOLS=1
 	    AC_DEFINE(HAVE_PRAGMA_CRI_DUP,1,[Define for CRAY weak dup])
         else    
             AC_MSG_RESULT(no)
         fi
@@ -1145,45 +1169,20 @@
         AC_DEFINE(NEEDS_INT_CAST_WITH_FLOCK,1,[Define if l_start and l_len data should be cast as int])
     fi
     # FIXME.  Solaris header files define off_t as a UNION if 64bit file
     # sizes are selected.  Gah!
 fi
 
 if test -n "$file_system_nfs" ; then
    # Check for problems with locks
-   AC_MSG_CHECKING([whether file locks work with NFS])
-   AC_TRY_RUN([
-#include <fcntl.h>
-#include <errno.h>
-#include <unistd.h>
-
-int main()
-{
-    struct flock lock;
-    int fd, err;
-
-    lock.l_type = F_WRLCK;
-    lock.l_start = 0;
-    lock.l_whence = SEEK_SET;
-    lock.l_len = 100;
-
-    fd = open("conftest.dat", O_RDWR | O_CREAT, 0644);
-
-    err = fcntl(fd, F_SETLKW, &lock);
-
-   /* printf("err = %d, errno = %d\n", err, errno); */
-    close(fd);
-    return err;
-}],nfs_locks_work=yes,nfs_locks_work=no,nfs_locks_work=unknown)
-    AC_MSG_RESULT($nfs_locks_work)
-    if test "$nfs_locks_work" != "yes" ; then
-        AC_MSG_WARN([File locks do not work with NFS.  See the Installation and
-users manual for instructions on fixing this])
-    fi
+   # We no longer do this within the configure test.  Instead,
+   # we suggest tha the user run maint/nfslock.c
+   AC_MSG_WARN([File locks may not work with NFS.  See the Installation and
+users manual for instructions on testing and if necessary fixing this])
 fi
 if test -n "$file_system_nfs"; then
     AC_DEFINE(NFS,1,[Define for NFS])
 fi
 if test -n "$file_system_ufs"; then
     AC_DEFINE(UFS,1,[Define for UFS])
 fi
 if test -n "$file_system_hfs"; then
@@ -1222,41 +1221,62 @@
         CFLAGS="$CFLAGS -DXFS_MEMALIGN=$pac_cv_memalignval"
     else
         AC_MSG_RESULT(assuming 128 for memory alignment)
         CFLAGS="$CFLAGS -DXFS_MEMALIGN=128"
     fi
 fi
 
 if test -n "$file_system_pvfs"; then
+    # Check for missing int64_t (intel version 8 compiler and -no-gcc
+    # selected)
+    AC_MSG_CHECKING([that pvfs.h can be compiled])
+    AC_TRY_COMPILE([
+#include <pvfs.h>
+],[],pvfs_header_ok=yes,pvfs_header_ok=no)
+    AC_MSG_RESULT($pvfs_header_ok)
+    if test "$pvfs_header_ok" = no -a "$ac_cv_sizeof_long_long" = 8 ; then
+        AC_MSG_CHECKING([if pvfs.h can be compiled if we define int64_t])
+        # Try again, but with int64_t
+        AC_TRY_COMPILE([
+typedef long long int int64_t;
+#include <pvfs.h>
+],[],pvfs_header_ok="yes with int64 definition")
+        AC_MSG_RESULT($pvfs_header_ok)
+    fi
+    if test "$pvfs_header_ok" = "yes with int64 definition" ; then
+        AC_DEFINE(ROMIO_PVFS_NEEDS_INT64_DEFINITION,1,[Define if int64_t must be defined for PVFS])
+    fi
+    if test "$pvfs_header_ok" != "no" ; then
    # Use ROMIO_PVFS instead of PVFS because FREEBSD defines PVFS.
     AC_DEFINE(ROMIO_PVFS,1,[Define for Romio with PVFS])
 fi
+fi
 if test -n "$file_system_pvfs2"; then
     AC_DEFINE(ROMIO_PVFS2,1,[Define for Romio with PVFS2])
 fi
 if test -n "$file_system_pfs"; then
     AC_DEFINE(PFS,1,[Define for PFS])
 fi
 if test -n "$file_system_testfs"; then
     AC_DEFINE(ROMIO_TESTFS,1,[Define for TESTFS])
 fi
 if test -n "$file_system_piofs"; then
     AC_DEFINE(PIOFS,1,[Define for PIOFS])
     USER_CFLAGS="$USER_CFLAGS -bI:/usr/include/piofs/piofs.exp"
     ROMIO_LFLAGS="$USER_FFLAGS -bI:/usr/include/piofs/piofs.exp"
     USER_FFLAGS="$USER_FFLAGS -bI:/usr/include/piofs/piofs.exp"
 fi
 if test -n "$mpi_mpich"; then
-   if test "$FROM_MPICH2" = no; then
-      AC_DEFINE(NEEDS_MPI_TEST,1,[Define if mpi_test needed])
-      AC_DEFINE(MPICH,1,[Define if using MPICH])
       if test -z "$arch_SX4" ; then
          MPIOF_H_INCLUDED=1
       fi
+   if test "$FROM_MPICH2" = no; then
+      AC_DEFINE(NEEDS_MPI_TEST,1,[Define if mpi_test needed])
+      AC_DEFINE(MPICH,1,[Define if using MPICH])
    fi
 fi
 if test -n "$mpi_sgi"; then
    AC_DEFINE(MPISGI,1,[Define if SGI MPI])
 fi
 if test -n "$mpi_lam"; then
    AC_DEFINE(MPILAM,1,[Define if using LAM/MPI])
 fi
@@ -1274,16 +1294,24 @@
 # package.  This is used only as part of the MPICH2 build, including 
 # the documentation targets mandoc, htmldoc, and latexdoc
 if test -z "$master_top_srcdir" ; then
     if test "$FROM_MPICH2" = yes ; then
         AC_MSG_WARN([Could not determine master_top_srcdir])
     fi
 fi
 AC_SUBST(master_top_srcdir)
+#
+# Get the master builddir (which may be imported from above)
+if test -z "$master_top_builddir" ; then
+    master_top_builddir=`pwd`
+fi
+export master_top_builddir
+AC_SUBST(master_top_builddir)
+
 # The following definitions are needed within adio/common/status_setb.c
 if test "$FROM_MPICH" = yes ; then
    AC_DEFINE(MPICH,1,[Define if compiling within MPICH])
 elif test "$FROM_MPICH2" = yes ; then 
    AC_DEFINE(MPICH2,1,[Define if compiling within MPICH2])
 elif test "$FROM_MPILAM" = yes ; then
    AC_DEFINE(MPILAM,1,[Define if compiling within LAM/MPI])
 fi
@@ -1309,21 +1337,27 @@
 	fi
     fi
 fi
 if test "$FROM_MPICH2" != no ; then
     # use the error handlers from MPICH2
     MPIO_EXTRA_OBJECTS=
     MPIO_EXTRA_TMP_POBJECTS=
     MPIO_EXTRA_REAL_POBJECTS=
+    # Use generalized request to get the multiple-completion routines
+    MPIO_REQOBJECTS=
+    MPIO_REQ_TMP_POBJECTS=
+    MPIO_REQ_REAL_POBJECTS=
 fi
 AC_SUBST(MPIO_EXTRA_OBJECTS)
 AC_SUBST(MPIO_EXTRA_TMP_POBJECTS)
 AC_SUBST(MPIO_EXTRA_REAL_POBJECTS)
-
+AC_SUBST(MPIO_REQOBJECTS)
+AC_SUBST(MPIO_REQ_TMP_POBJECTS)
+AC_SUBST(MPIO_REQ_REAL_POBJECTS)
 #
 if test $NOF77 = 1 ; then
    F77=":"
 else
    FORTRAN_TEST="fperf fcoll_test fmisc pfcoll_test" 
 fi
 #
 if test $WITHIN_KNOWN_MPI_IMPL = no ; then
@@ -1355,17 +1389,24 @@
    TEST_LIBNAME=""
    MPIRUN=$MPI_BIN_DIR/mpirun
    if test -n "$arch_SX4" || test -n "$arch_hpux" ; then
       TEST_F77=$MPI_BIN_DIR/mpif90
    else
       TEST_F77=$MPI_BIN_DIR/mpif77
    fi
    CC=$MPI_BIN_DIR/mpicc
-   EXTRA_DIRS="mpi-io/fortran mpi2-other/info mpi2-other/info/fortran mpi2-other/array mpi2-other/array/fortran"
+#   if test $FROM_MPICH2 != yes ; then
+#       BUILD_MPI_ARRAY=1
+#       BUILD_MPI_INFO=1
+#   fi
+   # A later test will insert the mpi2-other/info and array directories based
+   # on the value of BUILD_MPI_xxxx.  This lets MPICH2 turn these off,
+   # since MPICH2 provides these routines elsewhere
+   EXTRA_DIRS="mpi-io/fortran"
    # Some older implementations of the ADI do not include the 
    # MPID_Status_set_bytes routine.   This uses either the 
    # environment variable ADI3_WITHOUT_SET_BYTES or the
    # with arg --without-setbytes
    if test "$ADI2_WITHOUT_SET_BYTES" != yes -a \
            "$with_setbytes" != no ; then
        AC_DEFINE(HAVE_STATUS_SET_BYTES,1,[Define if have MPIR_Status_set_bytes])
    fi
@@ -1386,19 +1427,22 @@
 elif test $FROM_MPICH2 = yes ; then
    # For now, separate the mpich2 from mpich cases
    MPICH_HOME=`dirname $ROMIO_HOME`
    MPICH_HOME=`dirname $MPICH_HOME`
    MPICH_HOME=`dirname $MPICH_HOME`
    if test -z "$MPI_BIN_DIR" ; then MPI_BIN_DIR=$MPICH_HOME/bin ; fi
    # No special compiler script.
    # BUT we need the include paths
-   CC="$CC -I${use_top_srcdir}/src/include -I${top_build_dir}/src/include"
-   TEST_CC="$CC"
-   MPI_LIB="$LIBNAME"
+   # CC="$CC -I${use_top_srcdir}/src/include -I${top_build_dir}/src/include"
+   # TEST_CC="$CC"
+   # MPI_LIB="$LIBNAME"
+   CC=${top_build_dir}/bin/mpicc
+   TEST_CC=${top_build_dir}/bin/mpicc
+   TEST_F77=${top_build_dir}/bin/mpif77
    ROMIO_INCLUDE=""
    USER_CFLAGS=""
    USER_FFLAGS=""
    TEST_LIBNAME=""
    MPIRUN=$MPI_BIN_DIR/mpiexec
    #
    # Turn off the building of the Fortran interface and the Info routines
    EXTRA_DIRS=""
@@ -1446,18 +1490,24 @@
 fi
 AC_SUBST(EXTRA_SRC_DIRS)
 AC_SUBST(FILE_SYS_DIRS)
 
 #
 CFLAGS="$CFLAGS -DHAVE_ROMIOCONF_H"
 #
 
+if test -n "$MPIOF_H_INCLUDED"; then
+   F77MPIOINC=""
+else 
+   F77MPIOINC="include 'mpiof.h'"
+fi
+
 AC_CHECK_HEADERS(unistd.h,
-        AC_MSG_CHECKING(for large file defines)
+        AC_MSG_CHECKING([for large file defines])
         AC_TRY_COMPILE([
                 #include <unistd.h>
                 ], [
                 #ifndef _LFS64_LARGEFILE
                 #error no largefile defines
                 #endif
                 ],
                 CFLAGS="${CFLAGS} -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64"
@@ -1494,16 +1544,17 @@
 AC_SUBST(MAKE)
 AC_SUBST(arch_IRIX)
 AC_SUBST(ROMIO_HOME)
 AC_SUBST(LIBNAME)
 AC_SUBST(TEST_LIBNAME)
 AC_SUBST(LL)
 AC_SUBST(F77GETARG)
 AC_SUBST(F77IARGC)
+AC_SUBST(F77MPIOINC)
 AC_SUBST(FTESTDEFINE)
 AC_SUBST(FORTRAN_MPI_OFFSET)
 AC_SUBST(FROM_MPICH)
 AC_SUBST(FROM_MPICH2)
 AC_SUBST(FROM_LAM)
 AC_SUBST(WITHIN_KNOWN_MPI_IMPL)
 AC_SUBST(NEEDS_MPI_FINT)
 AC_SUBST(HAVE_MPI_INFO)
@@ -1521,16 +1572,17 @@
 AC_SUBST(MPI_FARRAY2)
 AC_SUBST(MPI_FARRAY3)
 AC_SUBST(MPI_FARRAY4)
 AC_SUBST(MPI_FARRAY5)
 AC_SUBST(MPI_FARRAY6)
 AC_SUBST(MPI_FARRAY7)
 AC_SUBST(MPI_OFFSET_KIND1)
 AC_SUBST(MPI_OFFSET_KIND2)
+AC_SUBST(MPIO_REQOBJECTS)
 AC_SUBST(TEST_CC)
 AC_SUBST(TEST_F77)
 AC_SUBST(ROMIO_INCLUDE)
 AC_SUBST(ROMIO_LFLAGS)
 AC_SUBST(ROMIO_LIBLIST)
 AC_SUBST(ROMIO_TCFLAGS)
 AC_SUBST(ROMIO_TCPPFLAGS)
 AC_SUBST(ROMIO_TFFLAGS)
@@ -1541,16 +1593,17 @@
 AC_SUBST(MAKE_DEPEND_C)
 dnl
 dnl Support shared libraries
 if test -z "$ENABLE_SHLIB" ; then
    ENABLE_SHLIB=none
 fi
 AC_SUBST(ENABLE_SHLIB)
 AC_SUBST(CC_SHL)
+AC_SUBST(LIBTOOL)
 # Remove the .a from the library file name (so that we can use .so or
 # other appropriate suffix)
 SHLIBNAME=`echo $LIBNAME | sed 's/\.a//'`
 AC_SUBST(SHLIBNAME)
 dnl
 if test ! -d adio ; then mkdir adio ; fi
 if test ! -d adio/include ; then mkdir adio/include ; fi
 if test ! -d mpi2-other ; then mkdir mpi2-other ; fi
@@ -1584,23 +1637,13 @@
 Please register your copy of ROMIO with us by sending email
 to majordomo@mcs.anl.gov with the message
 subscribe romio-users
 This will enable us to notify you of new releases of ROMIO
 as well as bug fixes.
 
 EOF
 fi
-if test $FROM_MPICH2 = yes -a "$NOF77" = 0 ; then
-      sed 5d test/fcoll_test.f > test/tmp
-      mv test/tmp test/fcoll_test.f
-      sed 5d test/pfcoll_test.f > test/tmp
-      mv test/tmp test/fcoll_test.f
-      sed 5d test/fperf.f > test/tmp
-      mv test/tmp test/fperf.f
-      sed 5d test/fmisc.f > test/tmp
-      mv test/tmp test/fmisc.f
-fi
 if test $FROM_MPICH = no -a $FROM_MPICH2 = no ; then
    AC_MSG_RESULT([Configure done. Now type make])
 fi
 dnl PAC_SUBDIR_CACHE_CLEANUP
 exit 0
Index: romio/adio/ad_hfs/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_hfs/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/adio/ad_hfs/.cvsignore	1 Aug 2003 13:30:17 -0000	1.2
+++ romio/adio/ad_hfs/.cvsignore	19 Jan 2004 14:49:35 -0000	1.3
@@ -1,2 +1,4 @@
 Makefile
 .deps
+*.bb
+*.bbg
Index: romio/adio/ad_nfs/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_nfs/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/adio/ad_nfs/.cvsignore	1 Aug 2003 13:30:17 -0000	1.2
+++ romio/adio/ad_nfs/.cvsignore	19 Jan 2004 14:49:35 -0000	1.3
@@ -1,2 +1,4 @@
 Makefile
 .deps
+*.bb
+*.bbg
Index: romio/adio/ad_ntfs/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_ntfs/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/adio/ad_ntfs/.cvsignore	1 Aug 2003 13:30:17 -0000	1.2
+++ romio/adio/ad_ntfs/.cvsignore	19 Jan 2004 14:49:35 -0000	1.3
@@ -1,2 +1,4 @@
 Makefile
 .deps
+*.bb
+*.bbg
Index: romio/adio/ad_pfs/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pfs/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/adio/ad_pfs/.cvsignore	1 Aug 2003 13:30:17 -0000	1.2
+++ romio/adio/ad_pfs/.cvsignore	19 Jan 2004 14:49:35 -0000	1.3
@@ -1,2 +1,4 @@
 Makefile
 .deps
+*.bb
+*.bbg
Index: romio/adio/ad_piofs/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_piofs/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/adio/ad_piofs/.cvsignore	1 Aug 2003 13:30:18 -0000	1.2
+++ romio/adio/ad_piofs/.cvsignore	19 Jan 2004 14:49:36 -0000	1.3
@@ -1,2 +1,4 @@
 Makefile
 .deps
+*.bb
+*.bbg
Index: romio/adio/ad_pvfs/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/adio/ad_pvfs/.cvsignore	1 Aug 2003 13:30:18 -0000	1.2
+++ romio/adio/ad_pvfs/.cvsignore	19 Jan 2004 14:49:36 -0000	1.3
@@ -1,2 +1,4 @@
 Makefile
 .deps
+*.bb
+*.bbg
Index: romio/adio/ad_pvfs/ad_pvfs.h
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs/ad_pvfs.h,v
retrieving revision 1.3
retrieving revision 1.5
--- romio/adio/ad_pvfs/ad_pvfs.h	24 Oct 2002 17:00:57 -0000	1.3
+++ romio/adio/ad_pvfs/ad_pvfs.h	7 Jun 2004 19:26:28 -0000	1.5
@@ -1,19 +1,27 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: ad_pvfs.h,v 1.3 2002/10/24 17:00:57 gropp Exp $    
+ *   $Id: ad_pvfs.h,v 1.5 2004/06/07 19:26:28 gropp Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #ifndef AD_PVFS_INCLUDE
 #define AD_PVFS_INCLUDE
 
+#ifndef ROMIOCONF_H_INCLUDED
+#include "romioconf.h"
+#define ROMIOCONG_H_INCLUDED
+#endif
+#ifdef ROMIO_PVFS_NEEDS_INT64_DEFINITION
+typedef long long int int64_t;
+#endif
+
 #include <unistd.h>
 #include <sys/types.h>
 #include <sys/uio.h>
 #include <fcntl.h>
 #include <pvfs.h>
 #include "adio.h"
 #include "pvfs_proto.h"
 
Index: romio/adio/ad_pvfs/ad_pvfs_flush.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs/ad_pvfs_flush.c,v
retrieving revision 1.11
retrieving revision 1.12
--- romio/adio/ad_pvfs/ad_pvfs_flush.c	18 Apr 2003 20:15:01 -0000	1.11
+++ romio/adio/ad_pvfs/ad_pvfs_flush.c	20 May 2004 19:05:17 -0000	1.12
@@ -1,26 +1,38 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: ad_pvfs_flush.c,v 1.11 2003/04/18 20:15:01 David Exp $    
+ *   $Id: ad_pvfs_flush.c,v 1.12 2004/05/20 19:05:17 robl Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "ad_pvfs.h"
 
 void ADIOI_PVFS_Flush(ADIO_File fd, int *error_code)
 {
-    int err;
+    int err, rank, dummy=0, dummy_in=0;
 #ifndef PRINT_ERR_MSG
     static char myname[] = "ADIOI_PVFS_FLUSH";
 #endif
 
+    /* a collective routine: because we do not cache data in PVFS1, one process
+     * can initiate the fsync operation and broadcast the result to the others.
+     * One catch: MPI_File_sync has special meaning with respect to file system
+     * consistency.  Ensure no clients have outstanding write operations.
+     */
+
+    MPI_Comm_rank(fd->comm, &rank);
+    MPI_Reduce(&dummy_in, &dummy, 1, MPI_INT, MPI_SUM, 
+		    fd->hints->ranklist[0], fd->comm);
+    if (rank == fd->hints->ranklist[0]) {
     err = pvfs_fsync(fd->fd_sys);
+    }
+    MPI_Bcast(&err, 1, MPI_INT, 0, fd->comm);
 
     if (err == -1) {
 #ifdef MPICH2
 	*error_code = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, myname, __LINE__, MPI_ERR_IO, "**io",
 	    "**io %s", strerror(errno));
 #elif defined(PRINT_ERR_MSG)
 	*error_code = MPI_ERR_UNKNOWN;
 #else /* MPICH-1 */
Index: romio/adio/ad_pvfs/ad_pvfs_resize.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs/ad_pvfs_resize.c,v
retrieving revision 1.11
retrieving revision 1.13
--- romio/adio/ad_pvfs/ad_pvfs_resize.c	18 Apr 2003 20:15:01 -0000	1.11
+++ romio/adio/ad_pvfs/ad_pvfs_resize.c	7 Jun 2004 16:42:26 -0000	1.13
@@ -1,26 +1,35 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: ad_pvfs_resize.c,v 1.11 2003/04/18 20:15:01 David Exp $    
+ *   $Id: ad_pvfs_resize.c,v 1.13 2004/06/07 16:42:26 gropp Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "ad_pvfs.h"
 
 void ADIOI_PVFS_Resize(ADIO_File fd, ADIO_Offset size, int *error_code)
 {
     int err;
+    int ret, rank;
 #ifndef PRINT_ERR_MSG
     static char myname[] = "ADIOI_PVFS_RESIZE";
 #endif
     
+    /* because MPI_File_set_size is a collective operation, and PVFS1 clients
+     * do not cache metadata locally, one client can resize and broadcast the
+     * result to the others */
+    MPI_Comm_rank(fd->comm, &rank);
+    if (rank == fd->hints->ranklist[0]) {
     err = pvfs_ftruncate64(fd->fd_sys, size);
+    }
+    MPI_Bcast(&err, 1, MPI_INT, 0, fd->comm);
+
     if (err == -1) {
 #ifdef MPICH2
 	*error_code = MPIR_Err_create_code(MPI_SUCCESS, MPIR_ERR_RECOVERABLE, myname, __LINE__, MPI_ERR_IO, "**io",
 	    "**io %s", strerror(errno));
 #elif defined(PRINT_ERR_MSG)
 	*error_code = MPI_ERR_UNKNOWN;
 #else /* MPICH-1 */
 	*error_code = MPIR_Err_setmsg(MPI_ERR_IO, MPIR_ADIO_ERROR,
Index: romio/adio/ad_pvfs2/.cvsignore
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs2/.cvsignore,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/adio/ad_pvfs2/.cvsignore	1 Aug 2003 13:30:18 -0000	1.2
+++ romio/adio/ad_pvfs2/.cvsignore	19 Jan 2004 14:49:36 -0000	1.3
@@ -1,2 +1,5 @@
 Makefile
 .deps
+*.bb
+*.bbg
+
Index: romio/adio/ad_pvfs2/ad_pvfs2_close.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs2/ad_pvfs2_close.c,v
retrieving revision 1.2
retrieving revision 1.3
--- romio/adio/ad_pvfs2/ad_pvfs2_close.c	27 Jun 2003 23:23:16 -0000	1.2
+++ romio/adio/ad_pvfs2/ad_pvfs2_close.c	20 May 2004 19:13:57 -0000	1.3
@@ -1,19 +1,22 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: ad_pvfs2_close.c,v 1.2 2003/06/27 23:23:16 robl Exp $
+ *   $Id: ad_pvfs2_close.c,v 1.3 2004/05/20 19:13:57 robl Exp $
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "ad_pvfs2.h"
 
 void ADIOI_PVFS2_Close(ADIO_File fd, int *error_code)
 {
     ADIOI_Free(fd->fs_ptr);
-    /* pvfs2 doesn't have a 'close' */
+    /* pvfs2 doesn't have a 'close', but MPI-IO semantics dictate that we
+     * ensure all data has been flushed  */
+    /* XXX: reduce and sync? sync on all? */
+
     *error_code = MPI_SUCCESS;
 }
 /* 
  * vim: ts=8 sts=4 sw=4 noexpandtab 
  */
Index: romio/adio/ad_pvfs2/ad_pvfs2_common.c
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs2/ad_pvfs2_common.c,v
retrieving revision 1.7
retrieving revision 1.9
--- romio/adio/ad_pvfs2/ad_pvfs2_common.c	5 Sep 2003 20:43:58 -0000	1.7
+++ romio/adio/ad_pvfs2/ad_pvfs2_common.c	25 Mar 2004 22:17:45 -0000	1.9
@@ -1,75 +1,63 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*- */
 /* 
- *   $Id: ad_pvfs2_common.c,v 1.7 2003/09/05 20:43:58 robl Exp $
+ *   $Id: ad_pvfs2_common.c,v 1.9 2004/03/25 22:17:45 robl Exp $
  *
  *   Copyright (C) 2003 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #include "ad_pvfs2.h"
 #include "ad_pvfs2_common.h"
 #include <unistd.h>
 #include <sys/types.h>
 
 /* maybe give romio access to the globalconfig struct */
 /* keyval hack to both tell us if we've already initialized pvfs2 and also
  * close it down when mpi exits */
 int ADIOI_PVFS2_Initialized = MPI_KEYVAL_INVALID;
 
-PVFS_fs_id * ADIOI_PVFS2_fs_id_list;
-pvfs_mntlist ADIOI_PVFS2_mntlist;
-
 void ADIOI_PVFS2_End(int *error_code)
 {
     int ret;
     ret = PVFS_sys_finalize();
     if (ret < 0 ) {
-	*error_code = MPI_UNDEFINED;
+	ADIOI_PVFS2_pvfs_error_convert(ret, error_code);
     } else {
 	*error_code = MPI_SUCCESS;
     }
 }
 
 int ADIOI_PVFS2_End_call(MPI_Comm comm, int keyval, 
 	void *attribute_val, void *extra_state)
 {
     int error_code;
     ADIOI_PVFS2_End(&error_code);
     return error_code;
 }
 
 void ADIOI_PVFS2_Init(int *error_code )
 {
-	PVFS_sysresp_init resp_init;
 	int ret;
 
 	/* do nothing if we've already fired up the pvfs2 interface */
 	if (ADIOI_PVFS2_Initialized != MPI_KEYVAL_INVALID) {
 		*error_code = MPI_SUCCESS;
 		return;
 	}
 
-	ret = PVFS_util_parse_pvfstab(&ADIOI_PVFS2_mntlist);
-	if (ret < 0) {
-	    /* XXX: better error handling */
-	    fprintf(stderr, "error parsing pvfstab\n");
-	    *error_code = MPI_UNDEFINED;
-	    return;
-	}
-	ret = PVFS_sys_initialize(ADIOI_PVFS2_mntlist, ADIOI_PVFS2_DEBUG_MASK, 
-		&resp_init);
+	ret = PVFS_util_init_defaults();
 	if (ret < 0 ) {
 	    /* XXX: better error handling */
-	    fprintf(stderr, "error initializing pvfs\n");
-	    *error_code = MPI_UNDEFINED;
+	    PVFS_perror("PVFS_util_init_defaults", ret);
+	    ADIOI_PVFS2_pvfs_error_convert(ret, error_code);
 	    return;
 	}
-	ADIOI_PVFS2_fs_id_list = resp_init.fsid_list;
+
 	MPI_Keyval_create(MPI_NULL_COPY_FN, ADIOI_PVFS2_End_call,
 		&ADIOI_PVFS2_Initialized, (void *)0); 
 	/* just like romio does, we make a dummy attribute so we 
 	 * get cleaned up */
 	MPI_Attr_put(MPI_COMM_WORLD, ADIOI_PVFS2_Initialized, (void *)0);
 }
 
 void ADIOI_PVFS2_makeattribs(PVFS_sys_attr * attribs)
@@ -82,18 +70,17 @@
     attribs->mask =  PVFS_ATTR_SYS_ALL_SETABLE;
 }
 
 
 void ADIOI_PVFS2_makecredentials(PVFS_credentials * credentials)
 {
     memset(credentials, 0, sizeof(PVFS_credentials));
 
-    credentials->uid = geteuid();
-    credentials->gid = getegid();
+    PVFS_util_gen_credentials(credentials);
 }
 
 /* pvfs_error_convert: given a pvfs error code, make it into the appropriate
  * mpi error code */ 
 int ADIOI_PVFS2_pvfs_error_convert(int pvfs_error, int *mpi_error)
 {
     *mpi_error = MPI_UNDEFINED;
     return 0;
Index: romio/adio/ad_pvfs2/ad_pvfs2_common.h
===================================================================
RCS file: /home/MPI/cvsMaster/romio/adio/ad_pvfs2/ad_pvfs2_common.h,v
retrieving revision 1.8
retrieving revision 1.10
--- romio/adio/ad_pvfs2/ad_pvfs2_common.h	18 Sep 2003 23:13:18 -0000	1.8
+++ romio/adio/ad_pvfs2/ad_pvfs2_common.h	25 Mar 2004 22:22:34 -0000	1.10
@@ -1,11 +1,11 @@
 /* -*- Mode: C; c-basic-offset:4 ; -*-
  * vim: ts=8 sts=4 sw=4 noexpandtab
- *   $Id: ad_pvfs2_common.h,v 1.8 2003/09/18 23:13:18 robl Exp $    
+ *   $Id: ad_pvfs2_common.h,v 1.10 2004/03/25 22:22:34 robl Exp $    
  *
  *   Copyright (C) 1997 University of Chicago. 
  *   See COPYRIGHT notice in top-level directory.
  */
 
 #ifndef _AD_PVFS2_h
 #define _AD_PVFS2_H
 #include "ad_pvfs2.h"
@@ -13,24 +13,22 @@
 /* useful values:
  *  0:		    no debugging
  *  CLIENT_DEBUG:   debug client state machines
  */
 #define ADIOI_PVFS2_DEBUG_MASK 0
 
 
 struct ADIOI_PVFS2_fs_s {
-    PVFS_pinode_reference pinode_refn;
+    PVFS_object_ref object_ref;
     PVFS_credentials credentials;
 } ADIOI_PVFS2_fs_s;
 
 typedef struct ADIOI_PVFS2_fs_s ADIOI_PVFS2_fs;
 
-extern PVFS_fs_id * ADIOI_PVFS2_fs_id_list;
-extern pvfs_mntlist ADIOI_PVFS2_mntlist;
 
 void ADIOI_PVFS2_Init(int *error_code );
 void ADIOI_PVFS2_makeattribs(PVFS_sys_attr * attribs);
 void ADIOI_PVFS2_makecredentials(PVFS_credentials * credentials);
 void ADIOI_PVFS2_End(int *error_code);
 int ADIOI_PVFS2_End_call(MPI_Comm comm, int keyval, 
 	void *attribute_val, void *extra_state);
 int ADIOI_PVFS2_pvfs_error_convert(int pvfs_error, int *mpi_error);
